{ Turbo Delphi }

program portals;

uses SysUtils;

type rebro = record
  v, t, c: longint;
end;

procedure swap(var a, b: rebro);
  var c: rebro;
  begin
    c := a; a := b; b := c;
  end;

var fin, fout: text;
    i, j, ans, m, n, mm, a, b: longint;
    mat: array[1..1000, 1..1000] of boolean;
    reb: array[1..1000000] of rebro;
    cost, col: array[1..1000] of longint;

procedure sort(l, r: longint);
  var i, j: longint;
      etl: rebro;
  begin
    if l < r then
      begin
        etl := reb[random(r - l) + l];
        i := l; j := r;
        while i < j do
          begin
            while reb[i].c < etl.c do inc(i);
            while reb[j].c > etl.c do dec(j);
            if i <= j then
              begin
                swap(reb[i], reb[j]);
                inc(i); dec(j);
              end;
          end;
        sort(l, j); sort(i, r);
      end;
  end;

function color(x: longint): longint;
  begin
    if col[x] = x then color := x else
      color := color(col[x]);
  end;

begin
  assign(fin, 'portals.in');
  assign(fout, 'portals.out');
  reset(fin); rewrite(fout);
  read(fin, n, m);
  fillchar(mat, sizeof(mat), false);
  for i := 1 to n do read(fin, cost[i]);
  mm := 0;
  for i := 1 to m do
    begin
      read(fin, a, b);
      mat[a, b] := true; mat[b, a] := true;
      inc(mm);
      reb[mm].v := a; reb[mm].t := b; reb[mm].c := 0;
    end;
  for i := 1 to n do
    for j := i + 1 to n do
      if not mat[i, j] then
        begin
          inc(mm);
          reb[mm].v := i; reb[mm].t := j; reb[mm].c := cost[i] + cost[j];
        end;
  for i := 1 to n do col[i] := i;
  sort(1, mm);
  ans := 0;
  for i := 1 to mm do
    begin
      if color(reb[i].v) <> color(reb[i].t) then
        begin
          col[color(reb[i].t)] := reb[i].v;
          ans := ans + reb[i].c;
        end;
    end;
  writeln(fout, ans);
  close(fin); close(fout);
end.