{ Turbo Delphi }

type
  ajaja = record
    k, port: longint;
  end;
  Tajaja = array[1 .. 1010] of ajaja;

var
  n, m, i, x, y, j, temp: longint;
  p: Tajaja;
  ans: int64;
  tree: array[1 .. 1010] of longint;

procedure quicksort(var p: Tajaja; n: longint);

procedure qsort(left, right: longint);
var
  i, j, e: longint;
  temp: ajaja;

begin
  i := left;
  j := right;
  e := p[random(j - i + 1) + i].k;
  while i < j do
  begin
    while p[i].k < e do inc(i);
    while p[j].k > e do dec(j);
    if i <= j then
    begin
      temp := p[i];
      p[i] := p[j];
      p[j] := temp;
      inc(i);
      dec(j);
    end;
  end;
  if i < right then qsort(i, right);
  if left < j then qsort(left, j);
end;

begin
  qsort(1, n);
end;

begin
  reset(input, 'portals.in');
  rewrite(output, 'portals.out');
  read(n, m);
  for i := 1 to n do
  begin
    read(p[i].k);
    tree[i] := i;
    p[i].port := i;
  end;
  quicksort(p, n);
  for i := 1 to m do
  begin
    read(x, y);
    if tree[x] <> tree[y] then
    begin
      temp := tree[y];
      for j := 1 to n do
        if tree[j] = temp then
          tree[j] := tree[x];
    end;
  end;
  ans := 0;
  for i := 2 to n do
  begin
    if tree[p[1].port] <> tree[p[i].port] then
    begin
      temp := tree[p[i].port];
      ans := ans + p[i].k + p[1].k;
      for j := 1 to n do
        if tree[j] = temp then
          tree[j] := tree[p[1].port];
    end;
  end;
  writeln(ans);
end.
