{ Turbo Delphi }

program portals;
const n_max = 1000;


type rebro =  record
     a: word;
     b: word;
     w: longint; end;
type group =              record
     v: array [1..n_max] of word;
     n: word;
     min: longint;           end;
type planet =             record
     v: array [1..n_max] of word;
     n: word;                end;
var o: text;
    p: array [1..n_max] of longint;
//    reb: array [1..n_max*n_max] of rebro;
    gr: array [1..n_max] of group;
    pl: array [1..n_max] of planet;
    n0: array [0..1,1..n_max] of word;           //for bfs
    k0,k1: word;                               //for bfs
    i0,i1: byte;                               //for bfs
    N,M,R,i: longint;
    a,b: word;
    coun,nt,R_MIN: longint;
    st: array [1..n_max] of byte;
    tree: array [1..n_max] of longint;
    treeC,TreeMIN: longint;
    ANSWER: longint;

procedure BFS(j: word);
var x,y,z,q,w: word;                                  begin  // bfs
st[j]:=1; i0:=0; i1:=1; k0:=1; k1:=0; n0[0,1]:=j;
gr[coun].n:=1; gr[coun].v[1]:=j;
repeat                              for y:=1 to k0 do begin
q:=n0[i0,y];
for z:=1 to pl[q].n do if st[pl[q].v[z]]=0 then       begin
st[pl[q].v[z]]:=1;  inc(k1);          n0[i1,k1]:=pl[q].v[z];
inc(gr[coun].n);         gr[coun].v[gr[coun].n]:=pl[q].v[z]; // add to group
                                                  end;  end;
k0:=k1; i0:=1-i0; i1:=1-i1;  k1:=0;              until k0=0;
                                                        end;

function  MIN(j: word):longint;                              //minimum price in gr
var  x_min: longint;  x: word;                        begin
     x_min:=1000000000;
for x:=1 to gr[j].n do if   x_min >p[gr[j].v[x]]
                       then x_min:=p[gr[j].v[x]];
min:=x_min;                                             end;
{
procedure qsort(left,right: word);                           // CHECKED !
var l,r: word;  t: longint; x: rebro;                 begin
l:=left;
r:=right;       t:=reb[(left+right) div 2].w;

repeat
while reb[l].w<t do inc(l);
while reb[r].w>t do dec(r);              if l<=r then begin
x:=reb[l]; reb[l]:=reb[r]; reb[r]:=x; inc(l); dec(r);   end;
until l>r;
if l<right then qsort(l,right);
if left<r  then qsort(left,r);                          end;
}

procedure sortgroups(left,right: word);                      // sort by gr.min
var l,r: word;  t: longint; x: group;                 begin
l:=left;
r:=right;       t:=gr[(left+right) div 2].min;

repeat
while gr[l].min<t do inc(l);
while gr[r].min>t do dec(r);             if l<=r then begin
x:=gr[l];  gr[l]:=gr[r];  gr[r]:=x;   inc(l); dec(r);   end;
until l>r;
if l<right then sortgroups(l,right);
if left<r  then sortgroups(left,r);                     end;

                                                      BEGIN
          assign(o,'portals.in');  reset(o);  readln(o,n,m);
          for i:=1 to n do pl[i].n:=0;
          for i:=1 to n do read(o,p[i]);      readln(o);
          for i:=1 to m do                            begin
          readln(o,a,b);  inc(pl[a].n); pl[a].v[pl[a].n]:=b;
                          inc(pl[b].n); pl[b].v[pl[b].n]:=a;
                                                        end; // O(N^2)
close(o); assign(o,'portals.out'); rewrite(o);
for i:=1 to N do gr[i].n:=0;
for i:=1 to N do st[i]:=0; coun:=0;
for i:=1 to N do if st[i]=0 then begin                       // O(n^2)
inc(coun);  bfs(i);                end;                      // new group

for i:=1 to coun do gr[i].min:=MIN(i);                 R:=0; // minimum price
                                                             // coun - number of groups
{ MODIFIED PRIMA'S ALGORITHM }

SortGroups(1,coun);

for i:=1 to coun do st[i]:=0;            nt:=1;    st[1]:=1; // 1-ST STEP
                                         TreeMIN:=gr[1].min;
                                         TreeC:=0;
repeat
for i:=1 to coun do if st[i]=0 then begin
st[i]:=1; inc(nt);
inc(treeC); Tree[TreeC]:=TreeMIN+gr[i].min;                  // ves novoi vershini
if TreeMIN>gr[i].min then TreeMIN:=gr[i].min;                // minimalnyi ves 
                                      end;
until nt=coun;

ANSWER:=0;
for i:=1 to treeC do ANSWER:=ANSWER+Tree[i];
writeln(o,ANSWER);  close(o);
                                                        END.












                                                        
{
for a:=1 to (coun-1) do for b:=a to coun do begin            // vse rebra mejdu gruppami
inc(R);  reb[r].a:=a;
         reb[r].b:=b;
         reb[r].w:=gr[a].min + gr[b].min;     end;           // O(N^2)

                                                             // R - kolichestvo reber sredi groups
for i:=1 to coun do st[i]:=0;                    qsort(1,R); // O(N^2 log N) !!!

{ PRIMA'S ALGORITHM }
{
st[reb[1].a]:=1;
st[reb[1].b]:=1;                                      nt:=2; // used V-s

treeC:=1;  tree[1]:=1;

repeat
for i:=1 to R do
if    ((st[reb[i].a]=1) and (st[reb[i].b]=0))                // a used b not used
   or ((st[reb[i].a]=0) and (st[reb[i].b]=1)) then    begin  // b used a not used
st[reb[i].a]:=1;
st[reb[i].b]:=1;                                    inc(nt);
inc(treeC);  tree[treeC]:=i;                            end; // O(N^3);
until nt=coun;


ANSWER:=0;
for i:=1 to treeC do ANSWER:=ANSWER+reb[tree[i]].w;
writeln(o,ANSWER);  close(o);                           END.
