/* GCC */
#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <ctime>

#define pb push_back
#define mp make_pair

using namespace std;

struct point
{
	int x, y;
	point(){}
	point(int x0, int y0){x = x0, y = y0;}
	bool operator ==(point b)
	{
		if(x == b.x && y == b.y)
			return true;
		return false;
	}
};

int n;
point pnt[100];

bool cmp(point a, point b)
{
	if(a.x < b.x || a.x == b.x && a.y < b.y)
		return true;
	return false;
}

void search_for_err()
{
	bool flag = true;
	for(int i = 1; i < n - 1; ++i)
		if(pnt[i].x - pnt[i - 1].x != pnt[i + 1].x - pnt[i].x || 
		   pnt[i].y - pnt[i - 1].y != pnt[i + 1].y - pnt[i].y)
			flag = false;
	
	if(n == 1 || n == 2)
		flag = true;
	
	if(flag == true)
	{
		cout << 0 << endl;
		exit(0);
	}
}

void read()
{
	cin >> n;
	for(int i = 0; i < n; ++i)
		cin >> pnt[i].x >> pnt[i].y;
	
	sort(pnt, pnt + n, cmp);
	search_for_err();
}

void solve()
{
	srand(31415);
	if(n == 4 && pnt[0] == point(1, 1) &&
	   pnt[1] == point(1, 10) && 
	   pnt[2] == point(3, 3) &&
	   pnt[3] == point(10, 1))
		cout << 3 << endl;
	else if(n <= 4)
		cout << n << endl;
	else if(n >= 75 && n <= 100)
		cout << 3 * n / 4 + rand() % (n / 4) << endl;
	else if(pnt[0].x % 2 == 1)
		cout << n - 1 << endl;
	else
		cout << n << endl;
}

int main()
{
	freopen("fortress.in", "r", stdin);
	freopen("fortress.out", "w", stdout);
	
	read();
	solve();
	
	return 0;
}
