/* GCC */

#include <cstdlib>
#include <iostream>
#include <set>
#include <vector>
#include <math.h>

using namespace std;

struct tp{
int x , y;
};
int n;

vector< tp > v;

int sq( tp a , tp b , tp c )
{
    return a.x*( b.y-c.y ) - b.x*( a.y-c.y ) + c.x*( a.y-b.y );
}

int f()
{
    vector< tp > st;
    st.push_back( v[0] );
    st.push_back( v[1] );
    for( int i = 2 ; i < n ; ++i )
    {
         if( sq( st[ st.size()-2 ] , st[ st.size()-1 ] , v[i] ) >= 0 && 
             sq( st[ st.size()-1 ] , v[i] , *st.begin() ) >= 0 && 
             sq( v[i] , st[0] , st[1] ) > 0 ) 
             
         st.push_back( v[i] );
    }

    
    if( st.size() == 3 )
    {
        if( sq( st[ st.size()-2 ] , st[ st.size()-1 ] , st[ st.size()-3 ] ) == 0 )
        return 0;
    }
    if( st.size() < 3 )
    return 0;
    return st.size();
}

int main()
{
    srand( 31415 );
    freopen( "fortress.in" , "r" , stdin );
    freopen( "fortress.out" , "w" , stdout );
    tp tmp;
    cin >> n;
    
    for( int i = 0 ; i < n ; ++i )
    {
         cin >> tmp.x >> tmp.y;
         v.push_back( tmp );     
    }
    int ans = 0;
    while( 1 )
    {
           ans = max( ans , f() );
           
           if( (double)clock()/(double)CLOCKS_PER_SEC > 0.07 )
           {
               cout << ans << endl;
               return 0;
           }
           random_shuffle( v.begin() , v.end() );
    }
    
    return 0;
}
