/* GCC */

#include <cstdlib>
#include <iostream>
#include <set>

using namespace std;

const int nmax = 1100;

int n , m;
int p[ nmax ]; 
int color[ nmax ];
int MN[ nmax ];
set< pair< int , int > > st;

int main()
{
    freopen( "portals.in" , "r" , stdin );
    freopen( "portals.out" , "w" , stdout );
    scanf( "%d%d" , &n , &m );
    for( int i = 1 ; i <= n ; ++i )
         scanf( "%d" , p+i );
      
    for( int i = 0 ; i < n ; ++i )
    {
         color[ i+1 ] = i+1; 
         MN[ i+1 ] = p[ i+1 ]; 
         st.insert( make_pair( MN[ i + 1 ] , i + 1 ) );
    }
    int a , b;
    
    for( int i = 0 ; i < m ; ++i )
    {
         scanf( "%d%d" , &a , &b );
         
         st.erase( make_pair( MN[ color[ a ] ] , color[ a ] ) );
         st.erase( make_pair( MN[ color[ b ] ] , color[ b ] ) );
         
         MN[ color[ b ] ] = min( MN[ color[ b ] ] , MN[ color[ a ] ] );
         
         for( int i = 1 ; i <= n ; ++i )
         if( i != a )
         if( color[ i ] == color[ a ] )
             color[ i ] = color[ b ];
         
         color[ a ] = color[ b ];
         
         
         st.insert( make_pair( MN[ color[ b ] ] , color[ b ] ) );
    }
    bool f = true;
    long long ans = 0;

    while( st.size() > 1 )
    {
          a = st.begin() -> second;
          st.erase( st.begin() );
          b = st.begin() -> second;
          st.erase( st.begin() );           
            
          for( int i = 1 ; i <= n ; ++i )
          if( color[ i ] == a )
              color[ i ] = b;
             
           
          ans += MN[ b ] + MN[ a ];  
                     
          MN[ b ] = min( MN[ b ] , MN[ a ] );
          st.insert( make_pair( MN[ b ] , b ) );
    }
    printf( "%lld\n" , ans );
    return 0;
}
