{ Turbo Delphi }

{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}

program fortress;

{$APPTYPE CONSOLE}

uses
  SysUtils,math;

const
nmax=105;
type
tm=record
    x,y:longint;
    tan:extended;
   end;
tmas=array[1..nmax]of tm; 

var mas:tmas;
    n:byte;

function cmp(a,b:tm):smallint;
 begin
   if a.tan<b.tan
   then cmp:=-1
   else if a.tan>b.tan
        then cmp:=1
        else if a.x<b.x
             then cmp:=-1
             else if a.x>b.x
                  then  cmp:=1
                  else if a.y<b.y
                       then cmp:=1
                       else
                       if a.y>b.y
                       then cmp:=-1
                       else cmp:=0;
 end;
var svap:tm;

procedure quick(l,r:byte);
 var i,j:longint;
     et:tm;
 begin
   i:=l; j:=r;
   et:=mas[random(r-l+1)+l];
   while i<j do
    begin
      while cmp(mas[i],et)<0 do inc(i);
      while cmp(mas[j],et)>0 do dec(j);
      if i<=j then  begin
                     svap:=mas[i];
                     mas[i]:=mas[j];
                     mas[j]:=svap;
                     inc(i);dec(j);
                    end;
    end;
    if l<j then quick(l,j);
    if i<r then quick(i,r);
 end;    

function prav(a,b,c:tm):boolean;
    begin
     if (c.x-a.x)*(b.y-a.y)<=(c.y-a.y)*(b.x-a.x)
     then prav:=true
     else prav:=false;
    end;

var f1,f2:text;
    zero:byte;
    i:byte;
    stack:tmas;
    top:longint;
    d:tm;
    flag:boolean;
begin
randomize;
assign(f1,'fortress.in');
reset(f1);
assign(f2,'fortress.out');
rewrite(f2);
read(f1,n);
if (n=1)or(n=2)then writeln(f2,0)
else
begin
zero:=1;
read(f1,mas[1].x,mas[1].y);
read(f1,mas[2].x,mas[2].y);
if mas[2].y<mas[zero].y
   then zero:=2
   else if (mas[2].y=mas[zero].y)and(mas[2].x<mas[zero].x)
         then zero:=2;         
flag:=true;       {0000000}
for i:=3 to n do
 begin
   read(f1,mas[i].x,mas[i].y);
   if (mas[i].x-mas[1].x)*(mas[2].y-mas[1].y)<>(mas[i].y-mas[1].y)*(mas[2].x-mas[1].x)
   then flag:=false;
   if mas[i].y<mas[zero].y
   then zero:=i
   else if (mas[i].y=mas[zero].y)and(mas[i].x<mas[zero].x)
         then zero:=i;
 end;
if flag then writeln(f2,0)
else begin
     d:=mas[zero];
     for i:=1 to n do
      begin
      mas[i].x:=mas[i].x-d.x;
      mas[i].y:=mas[i].y-d.y;
      mas[i].tan:=arctan2(mas[i].y,mas[i].x);
      end;
      quick(1,n);
      top:=2;
      stack[1]:=mas[1];
      stack[2]:=mas[2];
      mas[n+1]:=mas[1];
      for i:=3 to n+1 do
        begin
          if prav(stack[top-1],stack[top],mas[i])
          then begin
                inc(top);
                stack[top]:=mas[i];
               end
          else begin
                dec(top);
                while (top>1)and(prav(stack[top-1],stack[top],mas[i])=false)do
                 dec(top);
                inc(top);
                stack[top]:=mas[i];                 
               end;
          
        end;
        dec(top);
       writeln(f2,top); 
      end;
end;

close(f1);
close(f2);
end.
