/* GCC */
//#include<iostream>
#include<fstream>
#include<math.h>

#define MAXN 100

using namespace std;

int fortress(int n, int x[MAXN], int y[MAXN]) {
    if (n <= 2) return 0;

    bool degenerate = true;
    for (int i = 2; i < n; i++) {
        if ((x[i] - x[0])*(y[1] - y[0]) != (x[1] - x[0])*(y[i] - y[0])) {
            degenerate = false;
            break;
        }
    }
    if (degenerate) return 0;
    
    return n;
}

int main() {
    int n;
    int x[MAXN];
    int y[MAXN];

    ifstream fin("fortress.in");
    fin >> n;
    for (int i = 0; i < n; i++) fin >> x[i] >> y[i];
    fin.close();

    int res = fortress(n, x, y);

    ofstream fout("fortress.out");
    fout << res << "\n";
    fout.close();

    //cin.get();
    //cin.get();
}
