/* GCC */
#include <iostream>
#include <stdio.h>
#include <vector>
#include <queue>
using namespace std;

int conn[1001][1001], cost[1001];
int n, m;
bool wasin[1001] = {false,};
int dfs(int i);

int main(){
	freopen("portals.in", "r", stdin);
	freopen("portals.out", "w", stdout);
	int a, b; 
	vector<int> cleaks;
	for(int i = 0; i < 1001; i++) for(int j = 0; j < 1001; j++) conn[i][j] = 0;
	cin>>n>>m;
	for(int i = 0; i < n; i++) cin>>cost[i+1];
	for(int i = 0; i < m; i++){
		cin>>a>>b;
		conn[a][b] = conn[b][a] = 1;
	}
	for(int i = 1; i <= n; i++) if (!wasin[i]) cleaks.push_back(dfs(i));
	sort(cleaks.begin(), cleaks.end());
	int cost = 0;
	for(unsigned int i = 1; i < cleaks.size(); i++) cost += cleaks[i]+cleaks[0];
	cout<<cost<<endl;
}

int dfs(int i){
	int c, cst = cost[i];
	wasin[i] = true;
	queue<int> check;
	check.push(i);
	while(!check.empty()){
		c = check.front();
		check.pop();
		for(int i = 1; i <= n; i++) if (conn[c][i] && wasin[i] == false){
			wasin[i] = true;
			cst = min(cst, cost[i]);
			check.push(i);
		}
	}
	return cst;
}
