/* GCC */
#include <cstdlib>
#include <fstream>

using namespace std;
int n, m;
int p[1000], route[1000][1000];
int payment;
void ReadFile()
{

     
     int a, b;
     ifstream infile;
     infile.open("portals.in");
     infile>>n;
     infile>>m;
     for(int i = 0; i < n; i++)
     {
        infile>>p[i];    
     }
     
     for(int i = 0; i < n; i++)
     {
             for(int k = i+1; k < n; k++)
             {
                 route[i][k] = p[i]+p[k];      
             }        
     }
     
     for(int i = 0; i < m; i++)
     {
        infile>>a;
        infile>>b;
        route[a-1][b-1] = 0;
        route[b-1][a-1] = 0;        
     }          
}

void EstablishRoutes()
{
         for(int i = 0; i < n; i++)
         {
          for(int k = 0; k < n; k++)
          {           
           for(int j = 0; j < n; j++)
           {
           
                 if(route[i][k]+route[k][j]<route[i][j])
                 {
                  route[i][j] = route[i][k]+route[k][j];
                  route[j][i] = route[i][j];                                       
                 }                                       
           }        
          }        
         }    
}

void AddRoute(int a, int b)
{
     route[a][b] = 0;
     route[b][a] = 0;
     payment += p[a] + p[b];     
}

bool CheckRoutes()
{
     for(int i = 0; i < n; i++)
     {
      for(int k = 0; k < n; k++)
      {
        if((route[i][k] != 0)||(route[k][i] != 0)){ 
        AddRoute(i, k);       
        return false; }        
      }        
     }
     return true;    
}

void SaveFile()
{
     ofstream outfile;
     outfile.open("portals.out");
     outfile<<payment;
}

int main(int argc, char *argv[])
{
    payment = 0;
    ReadFile();
    EstablishRoutes();
    while(true)
    {
               if(CheckRoutes()==true)
               {
                 SaveFile();
                 return EXIT_SUCCESS;                       
               }else{
                 EstablishRoutes();      
               }    
    }
}

