{ Turbo Delphi }
program fortress;

{$APPTYPE CONSOLE}

uses
  SysUtils,math;
const epc = 1e-8;
var x,y,st:array[0 .. 1000] of int64;
polar : array[0 .. 1000] of extended;
i,j,z,n,top,q : integer;
ans : integer;
used:array[0 .. 1000] of boolean;
z1 : extended;
function ccw(i,j,k : integer) : int64;
begin
 ccw := (x[i]-x[j])*(y[i]-y[k])- (y[i]-y[j])*(x[i]-x[k]);
end;
function dist(t : integer) : int64;
begin
 dist := sqr(x[t] - x[q]) + sqr(y[t] - y[q]);
end;
begin
 assign(input,'fortress.in');reset(input);
 assign(output,'fortress.out');rewrite(output);
 readln(n);
 for i:=1 to n do
  readln(x[i],y[i]);
 q := 1;
 for i:=2 to n do
  if (x[i]< x[q]) or ((x[i]=x[q]) and (y[i]<y[q])) then
   q := i;
 fillchar(polar,sizeof(polar),0);
 for i:=1 to n do
  if i <> q then
  polar[i] := arctan2(y[i]-y[q],x[i]-x[q])
  else
   polar[i] := -100000;
 for i:=1 to n-1 do
  for j:=i+1 to n do
   if (polar[i] > Epc+polar[j]) or ( (abs(polar[i]-polar[j])<Epc) and
   (dist(i)<dist(j)) ) then
   begin
    z1 := polar[i];
    polar[i]:=polar[j];
    polar[j]:=z1;
    z:=x[i];
    x[i]:=x[j];
    x[j]:=z;
    z:=y[i];
    y[i]:=y[j];
    y[j]:=z;
    if (i=q) then q:=j else if j=q then q:=i;
   end;
 top := 2;
 st[1] := 1;
 st[2] := 2;
 for i:=3 to n do
 begin
  while (top>=2) and (ccw(st[top-1],st[top],i) < 0) do dec(top);
  inc(top);
  st[top] := i;
 end;
 fillchar(used,sizeof(used),0);
 for i:=1 to top do
  used[st[i]] := true;
 ans := top;
 for i:=1 to n do
  if not used[i] then
  begin
   for j:=1 to top-1 do
    if (ccw(i,st[j],st[j+1]) = 0) then
    begin
     inc(ans);
     used[i] := true;
     break;
    end;
   if (not used[i]) and (ccw(i,st[top],st[1])=0) then inc(ans);
  end;
  if ccw(st[1],st[2],st[top]) = 0 then writeln(0)
 else
  writeln(ans);
 close(input);
 close(output);
end.
