/* VC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

int prices[ 1000 ];
bool used_p[ 1000 ];

struct info
{
	vector<int> v;
	int min_price;
};


info graph [ 1000 ];

struct one_pair
{
	int a, b;
	bool used;
};

vector<one_pair> pairs;


int num_of_planets;
int num_of_pairs;
int aj, bj;

int main()
{
	ifstream infile( "portals.in" );
	ofstream outfile( "portals.out" );

	infile >> num_of_planets;
	infile >> num_of_pairs;

	for( int i = 0; i < num_of_planets; i++ )
	{
		infile >> prices[ i ];
	}
	for ( int i = 0; i < num_of_pairs; i++ )
	{
		one_pair pp;	
		infile >> pp.a;
		infile >> pp.b;
		pp.used = false;
		pairs.push_back( pp );
	}

	int current_group = 0;
	pairs[ 0 ].used = true;
	graph[ 0 ].v.push_back( pairs[ 0 ].a );
	graph[ 0 ].v.push_back( pairs[ 0 ].b );

	int start = 0;
	bool finded = true;
	bool cont = true;

	while ( cont )
	{
		while ( finded )
		{
			for ( int i = 0; i < num_of_pairs; i++ )
			{
				finded = false;
				if ( !pairs[ i ].used )
				{
					for ( unsigned int k = 0; k < graph[ current_group ].v.size(); k++ )
					{
						if ( ( pairs[ i ].a == graph[ current_group ].v[ k ] ) ||
							( pairs[ i ].b == graph[ current_group ].v[ k ] ) )
						{
							if ( ( pairs[ i ].a == graph[ current_group ].v[ k ] ) )
									graph[ current_group ].v.push_back( pairs[ i ].b );

							if ( ( pairs[ i ].b == graph[ current_group ].v[ k ] ) )
								graph[ current_group ].v.push_back( pairs[ i ].a );
							pairs[ i ].used = true;
							finded = true;
							i = 0;

							break;
						}
					}
				}
			}
		}
			cont = false;
			for ( int k = 0; k < num_of_pairs; k++ )
			{
				if ( !pairs[ k ].used )
				{
					current_group++;
					graph[ current_group ].v.push_back( pairs[ k ].a );
					graph[ current_group ].v.push_back( pairs[ k ].b );

					pairs[ k ].used = true;
					cont = true;
					finded = true;

					break;
				}
			}
	}
	for ( int i = 0; i < num_of_pairs; i++)
	{
		used_p[ pairs[ i ].a - 1 ] = true;
		used_p[ pairs[ i ].b - 1 ] = true;
	}
	for ( int i = 0; i < num_of_planets; i++ )
	{
		if ( !used_p[ i ] )
		{
			current_group++;
			graph[ current_group ].v.push_back( i + 1 );
		}
	}
	int m_price = 0;
	int absolute_min = 0;
	int elem = 0;

	absolute_min = prices[ graph[ 0 ].v[ 0 ] ];

	for ( int i = 0; i < ( current_group + 1 ); i++)
	{
		m_price = prices[ graph[ i ].v[ 0 ] - 1];

		for ( unsigned int k = 0; k < graph[ i ].v.size(); k++ )
		{
			if ( m_price > prices[ graph[ i ].v[ k ] - 1] )
			{
				m_price = prices[ graph[ i ].v[ k ] - 1 ];
			}
		}
		graph[ i ].min_price = m_price;
		if ( m_price < absolute_min )
		{
			absolute_min = m_price;
			elem = i;
		}
	}
	int sum = 0;
	for ( int i = 0; i < ( current_group + 1 ); i++)
	{
		if ( i != elem)
		{
			sum += graph[ i ].min_price;
		}
	}
	sum += absolute_min * current_group;

	outfile << sum << endl;

	infile.close();
	outfile.close();
}