{ Turbo Delphi }

program fortress;

uses SysUtils;

type point = record
  x, y: extended;
  n: byte;
end;

procedure swap(var a, b: point);
  var c: point;
  begin
    c := a; a := b; b := c;
  end;

var fin, fout: text;
    n, i, extr, k, max: longint;
    flag: boolean;
    points: array[1..101] of point;
    obol: array[1..101] of point;

const eps = 0.000001;

function comp(a, b, c: point): boolean;
  var tga, tgb: extended;
  begin
    if a.y = c.y then
      if a.x > c.x then tga := 1e+19
        else tga := -1e+19
        else tga := (a.x - c.x)/(a.y - c.y);
    if b.y = c.y then
      if b.x > c.x then tgb := 1e+19
        else tgb := -1e+19
        else tgb := (b.x - c.x)/(b.y - c.y);
    if (tga = tgb) then comp := a.x < b.x else
      comp := tga > tgb;
  end;

procedure sort(l, r: longint);
  var i, j: longint;
      etl: point;
  begin
    if l < r then
      begin
        etl := points[random(r - l) + l];
        i := l; j := r;
        while i < j do
          begin
            while comp(points[i], etl, points[1]) do inc(i);
            while comp(etl, points[j], points[1]) do dec(j);
            if i <= j then
              begin
                swap(points[i], points[j]);
                inc(i); dec(j);
              end;
          end;
        sort(l, j); sort(i, r);
      end;
  end;

function right(a, b, c: point): boolean;
  var v1, v2: point;
      vmnz: extended;
  begin
    v1.x := b.x - a.x; v1.y := b.y - a.y;
    v2.x := c.x - b.x; v2.y := c.y - b.y;
    vmnz := v1.x * v2.y - v1.y * v2.x;
    right := (vmnz >= -eps);
  end;

begin
  assign(fin, 'fortress.in');
  assign(fout, 'fortress.out');
  reset(fin); rewrite(fout);
  read(fin, n);
  for i := 1 to n do
    begin
      flag := true;
      read(fin, points[i].x, points[i].y);
      if i = 1 then extr := i else
        begin
          if (points[i].y < points[extr].y) or ((points[i].y = points[extr].y) and (points[i].x < points[extr].x))
            then extr := i;
          if (i > 2) then
            if abs((points[i].x - points[i - 1].x)*(points[i - 1].y - points[i - 2].y) - (points[i].y - points[i - 1].y)*(points[i - 1].x - points[i - 2].x)) > eps then
            flag := false;
        end;
    end;
  swap(points[1], points[extr]);
  sort(2, n);
  obol[1] := points[1]; obol[2] := points[2];
  points[n + 1] := points[1];
  max := 0;
  for i := 1 to n do points[i].n := i;
  if (n <= 2)or flag then writeln(fout, 0) else
    begin
      i := 3; k := 2;
      while i <= n + 1 do
        begin
          inc(k);
          obol[k] := points[i];
          while not right(obol[k - 2], obol[k - 1], obol[k]) do
            begin
              obol[k - 1] := obol[k]; dec(k);
            end;
          if right(obol[k - 1], obol[k], obol[1]) and (k > max) then max := k;
          inc(i);
        end;
      writeln(fout, max - 1);
    end;
  close(fin); close(fout);
end.
