/* GCC */
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define x first
#define y second

bool cmp(pair<int,int> a,pair<int,int> b)
{
	if(a.first==b.first) return a.second<b.second;
	return a.first<b.first;
}

int sqr(int x1, int y1, int x2, int y2, int x3, int y3)
{
	return (x3-x1)*(y2-y1)-(x2-x1)*(y3-y1);
}

int main()
{
	int n,i,j,x,y,s1,s2,ss,s,ch,mh,mv,max,t,l;
	freopen("fortress.in","r",stdin);
	freopen("fortress.out","w",stdout);
	cin>>n;
	vector< pair<int, int> > c(n),h(n),v(n);
	vector<int> sh(n),sv(n);
	for( i=0; i<n; i++)
	{
		cin>>x>>y;
		c[i]=make_pair(x,y);
	}
	if(n<3){cout<<"0\n"; return 0;}
	sort(c.begin(),c.end(),cmp);
	max=0; t=0; ss=0;
	for(l=0; l<n-2; l++)
	 {
	  ch=0;
	  h[l]=make_pair(1,l);
	  v[l]=make_pair(1,l);
	  sh[l]=0;
	  sh[l+1]=0;
	  h[l+1]=make_pair(2,l);
	  v[l+1]=make_pair(2,l);
	  sv[l]=0;
	  sh[l+1]=0;
	  for(i=l+2; i<n; i++)
	  {
	     mh=0;
	     mv=0;
		 sh[i]=0;
		 sv[i]=0;
		 for(j=i-1; j>=l; j--)
	     {
		     s1=sqr(c[h[j].y].x,c[h[j].y].y,c[j].x,c[j].y,c[i].x,c[i].y);
		     if(mh<h[j].x+1 && s1>=0) 
		        {mh=h[j].x+1; h[i]=make_pair(mh,j); sh[i]=s1;}
		     s2=sqr(c[v[j].y].x,c[v[j].y].y,c[j].x,c[j].y,c[i].x,c[i].y);
		     if(mv<v[j].x+1 && (s2<0 || j==l || (sh[i]>0 && s2==0)) )
		        {mv=v[j].x+1; v[i]=make_pair(mv,j); sv[i]=s2;}
	     }
	     if(max<mh+mv-2){max=mh+mv-2;t=i;ch=1;}
	  }
	  if(ch>0)
	  {
	   j=t;i=t;
	   s=0;
	   while(j>l ||i>l)
	   {
	      s1=sqr(c[l].x, c[l].y, c[h[j].y].x, c[h[j].y].y, c[j].x, c[j].y);
		  j=h[j].y;
		  s2=sqr(c[l].x, c[l].y, c[v[i].y].x ,c[v[i].y].y ,c[i].x ,c[i].y);
		  i=v[i].y;
		  if(s1<0){s1=-s1;}
		  if(s2<0){s2=-s2;}
		  s+=s1+s2;
	   }
	   ss=s;
	  }
	  if(max>=n-l && ss>0){break;}
	  if(ss==0){max=0;}
	}
	if(max<3 || ss==0){cout<<"0\n"; return 0;}
	cout<<max<<endl;
}
