{ Turbo Delphi }

type
  Tmas = record
    x, y: longint;
  end;
  TTmas = array[1 .. 100] of Tmas;

var
  n, i, j: byte;
  a: TTmas;
  vis: array[1 .. 100] of boolean;
  kx, ky: longint;
  tee: boolean;

procedure quicksort(var a: TTmas; n: longint);

procedure qsort(left, right: longint);
var
  i, j: longint;
  t, e: Tmas;

begin
  i := left;
  j := right;
  e := a[random(j - i + 1) + i];
  while i < j do
  begin
    while (a[i].x < e.x) or ((a[i].x = e.x) and (a[i].y < e.y)) do inc(i);
    while (a[j].x > e.x) or ((a[j].x = e.x) and (a[j].y > e.y)) do dec(j);
    if i <= j then
    begin
      t := a[i];
      a[i] := a[j];
      a[j] := t;
      inc(i);
      dec(j);
    end;
  end;
  if i < right then qsort(i, right);
  if left < j then qsort(left, j);
end;

begin
  qsort(1, n);
end;

begin
  reset(input, 'fortress.in');
  rewrite(output, 'fortress.out');
  read(n);
  for i := 1 to n do
    read(a[i].x, a[i].y);
  quicksort(a, n);
  tee := true;
  for i := 3 to n do
    if (a[i].x - a[i - 1].x) * (a[i - 1].y - a[i - 2].y) <>
       (a[i].y - a[i - 1].y) * (a[i - 1].x - a[i - 2].x) then
        tee := false;
  if tee then
    writeln('0')
  else writeln((a[3].y - a[1].x) * 2 - a[1].x * a[1]. y);
end.
