/* GCC */
#include <stdio.h>
#include <memory.h>

const int p = 41;

int n, m;
int a[5], st[5], g[5][30000];
__int64 d[4][30000], cnt;
bool flag;

void read()
{
	memset(d, -1, sizeof(d));
	
	scanf("%d %d", &n, &m);
	for(int i = 0; i < n; ++i)
	{
		scanf("%d", a + i);
		if(i > 0)
			if(a[i] > a[i - 1])
				flag = true;
	}
	
	if(flag) return;
	
	for(int j = 0; j < (1 << m); ++j)
		for(int k = 0; k < n; ++k)
			if(a[k] == j % p)
				g[k][st[k]++] = j;
}

int bs(int num, int &z)
{
	int l = 0, r = st[num] - 1;
	
	while(l < r - 1)
	{
		int mid = (l + r) / 2;
		if(g[num][mid] > z)
			r = mid;
		else
			l = mid + 1;
	}
	
	if(g[num][r] <= z)
		return r;
	else if(g[num][l] <= z)
		return l;
	else
		return l - 1;
}

__int64 bt(int cur, int level)
{
	if(d[level][cur] != -1)
		return d[level][cur];
	
	__int64 temp = 0;
	int t = bs(level + 1, g[level][cur]);
		
	if(level != n - 2)
	{
		for(int i = t; i >= 0; --i)
			if((g[level][cur] & g[level + 1][i]) == g[level + 1][i])
				temp += bt(i, level + 1);
			
		d[level][cur] = temp;
		return d[level][cur];
	}
	else
	{
		for(int i = t; i >= 0; --i)
			if((g[n - 2][cur] & g[n - 1][i]) == g[n - 1][i])
				++temp;
				
		d[n - 2][cur] = temp;
		return d[n - 2][cur];
	}
}		

void solve()
{
	if(!flag && n > 1)
		for(int i = 0; i < st[0]; ++i)
			cnt += bt(i, 0);
	else if(n == 1)
		cnt = st[0];
		
	printf("%I64d\n", cnt); 
}

int main()
{
	freopen("nested.in", "r", stdin);
	freopen("nested.out", "w", stdout);
	
	read();
	solve();
	
	return 0;
}
