{ Free Pascal }

var spots :array[1..100, 1..2] of integer;  n :integer;


function count:integer;

var upchain, downchain :array[1..100] of integer;  w, l1, l2, mins:integer;

  function cos(x, y :integer):double;
  var a, b, c:double;
  begin
    a := 1;
    b := sqr(spots[x, 1] - spots[y, 1]) + sqr(spots[x, 2] - spots[y, 2]);
    c := sqr(spots[x, 1] - 1 - spots[y, 1]) + sqr(spots[x, 2] - spots[y, 2]);
    cos := (a + b - c)/(2 * sqrt (a * b));
  end;

  procedure up;
  var i, pos, max :integer; maxcos:double; stepped :boolean;
  begin
    l1 := 1;
    pos := mins;
    stepped := true;

    while stepped do begin
      stepped := false;
      maxcos := -1;
      for i := 1 to n do begin

        if spots[i, 1] > spots[pos, 1] then
         if cos(pos, i) > maxcos then begin maxcos := cos(pos, i);
         max := i; stepped := true; end;

      end;
      if stepped then begin l1 := l1 + 1; pos := max; end;
    end;

  end;

  procedure down;
  var i, pos, min :integer; mincos:double; stepped :boolean;
  begin
    l2 := 1;
    pos := mins;
    stepped := true;

    while stepped do begin
      stepped := false;
      mincos := 1;
      for i := 1 to n do begin

        if spots[i, 1] > spots[pos, 1] then
         if cos(pos, i) < mincos then begin mincos := cos(pos, i);
         min := i; stepped := true; end;

      end;
      if stepped then begin l2 := l2 + 1; pos := min; end;
    end;

    min := 0;
    for i:= 1 to n do
      if spots[i, 2] = spots[pos, 2] then min := min + 1;
    if min > 1 then l2 := l2 + min - 1;
  end;

begin
  mins := 1;
  l1 := spots[1, 1];
  for w := 2 to n do
    if spots[w, 1] < l1  then begin mins := w; l1 := spots[w, 1]; end;
  up;
  down;
  if upchain[2] <> downchain[2] then count := l1 + l2 - 2 else count := 0;
end;

procedure reader;
var f :text; i :integer;
begin
  assign(f, 'fortress.in');
  reset(f);
  readln(f, n);
  for i := 1 to n do
    readln(f, spots[i, 1], spots[i, 2]);
  close(f);
end;

procedure writer(input :integer);
var f :text;
begin
  assign(f, 'fortress.out');
  rewrite(f);
  writeln(f, input);
  close(f);
end;

begin
  reader;
  writer(count);
end.