{ Free Pascal }

var graph :array[1..1000, 1..2] of longint; n :integer; m :longint;

procedure change(a, b :integer);
var i :integer;
begin
  for i := 1 to n do begin
    if graph[i, 2] = graph[a, 2] then graph[i, 2] := graph[b, 2];
    if graph[i, 1] = graph[a, 1] then graph[i, 1] := graph[b, 1];
  end;
end;

procedure init;
var f :text; i, a, b, min, res :longint; used :array[1..1000] of boolean;
begin
  for i := 1 to 1000 do
    used[i] := false;
  for i := 1 to 1000 do
    graph[i, 2] := i;
  assign(f, 'portals.in');
  reset(f);
  readln(f, n, m);
  for i := 1 to n do
    if i < n then read(f, graph[i, 1]) else readln(f, graph[i, 1]);
  for i := 1 to m do begin
    readln(f, a, b);
    if graph[a, 1] < graph[b, 1] then change(b, a) else change(a, b);
  end;
  close(f);
  a := 0;
  res := 0;
  for i := 1 to n do
    if used[graph[i, 2]] = false then begin
      used[graph[i, 2]] := true;
      a := a + 1;
      res := res + graph[i, 1];
      if min > graph[i, 1] then min := graph[i, 1];
    end;
  res := res + min * (a - 2);
  assign(f, 'portals.out');
  rewrite(f);
  writeln(f, res);
  close(f);
end;

begin
  init;
end.
