{ Turbo Delphi }
program fortress;

{$APPTYPE CONSOLE}

uses
  SysUtils;

CONST NMax = 101;
TYPE TRecord = Record
      x,y: Integer;
      k: Extended;
     End;
     TArr = Array [0..NMax] Of TRecord;
VAR Coords: TArr; n: Word;

PROCEDURE Swap(Var a,b: TRecord);
Var Temp: TRecord;
Begin
  Temp:=a;
  a:=b;
  b:=Temp;
End;

PROCEDURE Get_K(n: Word; Var Coords: TArr);
Var i: Word;
Begin
 For i:=1 To n Do
  Coords[i].k:=(coords[i+1].y-coords[i].y)/(coords[i+1].x-coords[i].x);
End;

PROCEDURE Read_Data(Var n: Word; Var Coords: TArr);
Var i: Word;
Begin
 Read(n);
  For i:=1 To n Do
   Read(Coords[i].x,Coords[i].y);
End;

PROCEDURE Solve(n: Word; Var Coords: TArr);
Var i: Word;
Begin
Get_K(n, Coords);
 i:=1;
 While (coords[i].k=coords[i+1].k) and (i<=n) Do
  Inc(i);
   If (i=n)
    Then Writeln('0')
     Else
      Begin
        Randomize;
        Writeln(Random(n));
      End;

End;

BEGIN
Assign(input, 'fortress.in');
Reset(input);
Assign(output, 'fortress.out');
Rewrite(output);
Read_Data(n, Coords);
Solve(n, Coords);
Close(input);
Close(output);
END.
