/* VC */

#include <iostream>

using namespace std;
////////////
int n, m;
	int a, b;
int cpSize;

int ** pA;
bool sorted = false;
////////////
struct planet
{
	int cost;
	int ID;
	int PortalStatus;
};
////////////
planet pP [1001];

int tmp, low;
int best_ID;

int costs[1001];

long RESULT = 0;

int cStatus[1001];
///////////////////////////////////////////////////////////
void CreateList(int * Table, int ** cList, int Num);

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////
int main()
{
	freopen("portals.in", "r", stdin);
		cin >> n;
		cin >> m;

	if(m == ( (n*(n-1)) / 2) )
	{
		freopen("portals.in", "r", stdout);
		cout << 0;
		return 0;
	}

	
	////////////////////Searching the best way/////////////////////////
		cin >> low;
		costs[1] = low;
		best_ID = 1;
	
	for(register int i = 2; i < n+1; i++)
	{
		cin >> costs[i];

		if(costs[i] < low)
		{
			low = costs[i];
			best_ID = i;	
		}
	}
	///////////////////////////////////////////////////////////////////
	
	/////////////////////Initializing connections statuses/////////////////////////////
	
	for(register int i = 1; i < n+1; i++)
		cStatus[i]++;
	////////////////////////////////////////////////////////////

	///////////////////Creating connections list/////////////////////////////
	int x=n+1;
	pA = new int * [x];
	for(register int i = 1; i < x; i++)
		pA[i] = new int [x];
	///////////////////////////////////////
	
	///////////////Clear number of connects////////////////////
	for(register int i = 1; i < x; i++)
		pA[i][0]=1;
	////////////////////////////////////

	/////////////////Initializing connections list//////////////////////
	for(register int i = 1; i < m+1; i++)
	{
		cin >> a;
		cin >> b;

		cpSize = pA[a][0];
		pA[a][cpSize] = b;
		pA[a][0]++;

		cpSize = pA[b][0];
		pA[b][cpSize] = a;
		pA[b][0]++;
	}
	////////////////////////////////////////////////////////////////

	/////////////////Creating connections on empty planets//////////////////////////
	for(register int i = 1; i < m; i++)
		if(pA[i][0] == 1)
		{
			pA[i][0]++;
			pA[i][1] = best_ID;
			
			cpSize = pA[best_ID][0];
			pA[best_ID][cpSize] = i;
			pA[best_ID][0]++;
			
			RESULT += low;
			RESULT += costs[i];
		}
	///////////////////////////////////////////////////////////////////////////////
	int ** pTable = new int * [n+1];
	int tSize = 0;

	for(register int i = 1; i< n+1; i++)
	{
		if(cStatus[i])
		{
			pTable[tSize] = new int [n+1];
			pTable[tSize][0] = 1;
			CreateList(pTable[tSize], pA, i);		
			
			tSize++;
		}
	}

	int * minimum = new int [tSize];
	
	for(int i = 0; i < tSize; i++)
	{
		int Size = pTable[i][0];
		minimum[i] = costs[pTable[i][1]];

		for(int j = 2; j < Size; j++)
			if(costs[pTable[i][j]] < minimum[i])
				minimum[i] = costs[pTable[i][j]];
	}
	int lastMin = minimum[0];
	
	for(int i = 0; i < tSize; i++)
	{
		if(minimum[i] < lastMin)
			lastMin = minimum[i];
		RESULT += minimum[i];
	}

	RESULT += lastMin*(tSize - 2);
	
	freopen("portals.out", "w", stdout);

	cout << RESULT;

	return 0;
}

void CreateList(int * Table, int ** cList, int Num)
{
	int Size = Table[0];
	Table[Size] = Num;
	Table[0]++;
	
	cStatus[Num] = 0;


	int cSize = cList[Num][0];

	for(register int i = 1; i < cSize; i++)
		if( cStatus[cList[Num][i]] == 1)
			CreateList(Table, cList, cList[Num][i]);
}