/* GCC */
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string>
#include <string.h>
#include <algorithm>
#include <vector>

using namespace std;

const int MAXN = 110;

// WTF?

struct pt
{int x, y;};

int ans;

int N, a, b;
pt p[MAXN];

int right(pt a, pt b, pt c)
{
	return (b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y);
}

int left(pt a, pt b, pt c)
{
	return (b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y);
}

bool cmp(pt a, pt b)
{
	if (a.x < b.x) return true;
	if (a.x > b.x) return false;
	return a.y < b.y;
}

void hull()
{
	sort(p, p + N, cmp);
	pt A, B;
	A = p[0];
	B = p[N - 1];
	vector < pt > up, down;
	up.push_back(A);
	down.push_back(A);
	int c = 0;
	for (int i = 1; i < N; ++i)
	{
		if (i == N - 1 || right(A, p[i], B) <= 0)
		{
			if (right(A, p[i], B) < 0) ++c;
			while (up.size() >= 2 && right(up[up.size() - 2], up[up.size() - 1], p[i]) > 0)
			{
				if (right(A, up[up.size() - 1], B) < 0) --c;
				up.pop_back();
			}
			up.push_back(p[i]);
		}

		if (i == N - 1 || left(A, p[i], B) >= 0)
		{
			if (left(A, p[i], B) > 0) ++c;
			while (down.size() >= 2 && left(down[down.size() - 2], down[down.size() - 1], p[i]) < 0)
			{
				if (left(A, down[down.size() - 1], B) > 0) --c;
				down.pop_back();
			}
			down.push_back(p[i]);
		}
	}
	
	if (c > 0)
	{
		ans = up.size() + down.size();
		for (int i = 0; i < up.size(); ++i)	
			for (int j = 0; j < down.size(); ++j)
				if (up[i].x == down[j].x && up[i].y == down[j].y)
					--ans;
	}
}

int main()
{
	freopen("fortress.in", "r", stdin);
	freopen("fortress.out", "w", stdout);
	scanf("%d", &N);
	for (int i = 0; i < N; ++i) 
		scanf("%d %d", &p[i].x, &p[i].y);
	hull();
	cout << ans << endl;
}