/* GCC */
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string>
#include <string.h>
#include <algorithm>
#include <vector>
#include <time.h>

using namespace std;

const unsigned long long MOD = 41;
const unsigned long long MOD2 = (unsigned long long)1e18;

int N, M;
int h[10];
unsigned long long dp[2][(1 << 20) + 10];
unsigned long long ans;
int calc[(1 << 20) + 10];

unsigned long long binpower(unsigned long long a, int n)
{
	if (n == 0)
		return 1;

	if (n % 2 == 0)
	{
		unsigned long long b = binpower(a, n / 2);
		return (b * b) % MOD;
	}
	else
	{
		unsigned long long b = binpower(a, n - 1);
		return (b * a) % MOD;
	}
}

unsigned long long calc2(unsigned long long m)
{
	unsigned long long res = 0;
	int i = M;
	while (m != 0)
	{
		if (m & 1)
			res = (res + binpower(2, i - 1)) % MOD;
		m >>= 1;
		--i;
	}
	return (res % MOD);
}

int main()
{
	freopen("nested.in", "r", stdin);
	freopen("nested.out", "w", stdout);
	scanf("%d %d", &N, &M);
	
	for (int i = 0; i < N; ++i) scanf("%d", &h[i]);
	
	bool f = false;

	for (int i = 0; i < (1 << M); ++i)
	{
		unsigned long long r = calc2(i);
		calc[i] = r;
		if (r == h[0])
		{
			dp[0][i] = 1;
			f = true;
		}
	}
	
	if (!f)
	{
		cout << 0 << endl;
		return 0;
	}

	for (int i = 0; i < N - 1; ++i)
	{
		for (int j = 0; j < (1 << M); ++j)
		{
			if (dp[0][j] != 0)
			{
				/*for (int k = 0; k < (1 << M); ++k)
				{
					if (((~j)&k) != 0) continue;
					unsigned long long r = calc[k];
					if (r == h[i + 1])
						dp[1][k] = (dp[1][k] + dp[0][j]) % MOD2;
				}*/
				
				for (int k = j; k >= 0; k = j & (k - 1))
				{
					unsigned long long r = calc[k];
					if (r == h[i + 1])
						dp[1][k] = (dp[1][k] + dp[0][j]) % MOD2;
					if (k == 0)
						break;
				}
			}
		}

		for (int j = 0; j < (1 << M) && i != N - 2; ++j)
		{
			dp[0][j] = dp[1][j];
			dp[1][j] = 0;
		}
	}
	
	if (N == 1)
	{
		for (int i = 0; i < (1 << M); ++i)
			ans = (ans + dp[0][i]) % MOD2;
	}
	else
	{
		for (int i = 0; i < (1 << M); ++i)
			ans = (ans + dp[1][i]) % MOD2;
	}
	cout << ans << endl;
}