/* GCC */
#include <iostream>
#include <vector>
#include <stdio.h>
#include <cmath>
using namespace std;
vector< vector<int> > modules;
int h[5], n, m;

int mod(int a){
	if (a >= 0) return a%41;
	else return 41+a;
}

long long find(int i, int cdev, int depth){
	long long ans = 0;
	if (depth == n){ return 1; }
	int ndev = h[depth];
	int u = mod(cdev-ndev);
	for(int j = 0; j < modules[u].size(); j++){
		if (modules[u][j] >= i) break;
		if ( (i|(i^(i-modules[u][j]))) != i) continue;
		ans += find(i-modules[u][j], ndev, depth+1);
	}
	return ans;
}

int main(){
	freopen("nested.in", "r", stdin);
	freopen("nested.out", "w", stdout);
	long long ans = 0;
	cin>>n>>m;
	for(int i = 0; i < n; i++) cin>>h[i];
	for(int i = 0; i < 41; i++){ vector<int> a; modules.push_back(a);}
	for(int i = 0; i < (1<<m); i++){
		modules[i%41].push_back(i);
	}
	for(int i = h[0]; i < (1<<m); i += 41){
		ans += find(i, h[0], 1);
	}
	cout<<ans<<endl;
}
