/* VC */
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <limits.h>
#include <algorithm>
using namespace std;

int p[1005], cst[1005], list[1005];

void mkset(int);
void unset(int, int);
int rdset(int);
bool cmp (int, int);

int main()
{
	int n, m;
	freopen("portals.in", "rt", stdin);
	freopen("portals.out", "wt", stdout);
	scanf("%d %d", &n, &m);
	for (int i=0; i<n; ++i)
	{
		mkset(i);
		scanf("%d", &cst[i]);
		list[i]=i;
	}
	int a, b;
	int sets=n;
	for (int i=0; i<m; ++i)
	{
		scanf("%d %d", &a, &b);
		if (rdset(a-1)!=rdset(b-1))
		{
			unset(a-1, b-1);
			--sets;
		}
	}
	sort(list, &list[n], cmp);
	int ans=0;
	a=0;
	while (sets>1)
	{
		b=a+1;
		while ((b<n)&&(sets>1))
		{
			if (rdset(list[a])!=rdset(list[b]))
			{
				unset(list[a], list[b]);
				--sets;
				ans+=(cst[list[a]]+cst[list[b]]);
			}
			++b;
		}
		++a;
	}
	cout<<ans<<endl;
}

void mkset(int i)
{
	p[i]=i;
}

void unset(int a, int b)
{
	while (p[b]!=b)
		b=p[b];
	while (p[a]!=a)
		a=p[a];
	p[a]=b;
}

int rdset(int a)
{
	while (p[a]!=a)
		a=p[a];
	return a;
}

bool cmp (int a, int b)
{
	if (cst[a]<cst[b])
		return true;
	return false;
}
