/* VC */
#include <iostream>
#include <memory.h>
#include <cstdlib>
#include <cstdio>
#define _USE_MATH_DEFINES
#include <math.h>
#include <vector>
#include <algorithm>
//#include <time.h>
using namespace std;
struct point{
	int x,y;
	point(){}
	point(int x,int y):x(x),y(y){}
	bool scan(){
		return cin>>x>>y;
	}
};
bool operator<(point a,point b){
	if (a.x!=b.x)return a.x<b.x;
	return a.y<b.y;
}
point operator-(point a,point b){
	point x=point(a.x-b.x,a.y-b.y);
	return x;
}
int turn(point a,point b){
	int rez=a.x*b.y-a.y*b.x;
	return rez;
}
int turn(point a,point b,point c){
	int rez=turn(b-a,c-b);
	return rez;
}
bool ok(point a,point b,point c)
{
	int xmi=min(b.x,c.x),xma=max(b.x,c.x),ymi=min(b.y,c.y),yma=max(b.y,c.y);
	if ((a.x>=xmi)&&(a.x<=xma)&&(a.y>=ymi)&&(a.y<=yma))	{
		return (a.x-b.x)*(c.y-b.y)==(a.y-b.y)*(c.x-b.x);
	}
	else
		return 0;
}
vector<point> convex(vector<point> a)//O(n log n)
{
	vector<point> u,d;
	sort(a.begin(),a.end());
	bool flag=1;
	for (int i=1;i<(int)a.size()-1;i++)
	{
		if (!ok(a[i],a[0],a[a.size()-1]))flag=0;
	}
	if (flag){
		a.clear();
		return a;
	}
	if (a.size()==0)return a;
	u.push_back(a[0]);
	d.push_back(a[0]);
	for (int i=1;i<(int)a.size();i++)
	{
		if ((turn(a[0],a[i],a[a.size()-1])<0)||(i==a.size()-1)){
			while ((u.size()>1)&&(turn(u[u.size()-2],u[u.size()-1],a[i])>0))u.pop_back();
			u.push_back(a[i]);
		}
		else{
			if (turn(a[0],a[i],a[a.size()-1])>0){
			while ((d.size()>1)&&(turn(d[d.size()-2],d[d.size()-1],a[i])<0))d.pop_back();
			d.push_back(a[i]);
			}
		}
	}
	reverse(d.begin(),d.end());
	u.insert(u.end(),d.begin(),d.end());
	u.pop_back();
	return u;
}
int f(vector<point> a)//o(n^2);
{
	vector<point> c=convex(a);
	int rez=0;
	for (int i=0;i<(int)a.size();i++)
	{
		bool flag=0;
		for (int j=0;j<(int)c.size();j++)
		{
			if (ok(a[i],c[j],c[(j+1)%c.size()]))
			{flag=1;break;}
		}
		if (flag)rez++;
	}
	return rez;
}
int n;
vector<point> vp;
vector<point> v;
int main()
{
	//time_t t=clock();
	freopen("fortress.in","r",stdin);
	freopen("fortress.out","w",stdout);
	//for (int i=0;i<10;i++)
	//{
	//	for (int j=0;j<10;j++)
	//		cout<<i<<" "<<j<<endl;
	//}
	cin>>n;
	if (n<3){cout<<0<<endl;exit(0);}
	vp.resize(n);
	for (int i=0;i<n;i++)
		vp[i].scan();
	int rez=f(v);
	if (n<=13)
	{
		for (int mask=7;mask<(1<<vp.size());mask++)
		{
			v.clear();
			for (int i=0;i<vp.size();i++)
			{
				if ((mask&(1<<i))!=0)
				{v.push_back(vp[i]);}
			}
			if (v.size()>rez)
			rez=max(rez,f(v));
		}
	}
	else
	{
		for (int i=0;i<n;i++)
		{
			v.clear();
			for (int j=0;j<n;j++)
			{
				if (j!=i){
					v.push_back(vp[j]);
				}
			}
			if (v.size()>rez)
			rez=max(rez,f(v));
		}
	}
	cout<<rez<<endl;
	//cout<<clock()-t<<endl;
}